
*****        
*       This program uses timer OC1 to increment the
*       data at memory location A1FF every 10mS.
*
*       Test program for 6811.exe monitor version 3.0
*       with memory between A000 and BFFF
*       December 1, 1994
*       Philip DeVries
*
*       The internal registers are assumed to be at 0000 - 003f
*****
        
*****
*       Equates
*****

*****
*       Register page 0
*****

TCNT    EQU     $000E
TOC1    EQU     $0016
TMSK1   EQU     $0022
TFLG1   EQU     $0023
COPRST  EQU     $003A

*****        
*       Loop to set up interrupts
*****

        
        ORG     $A000
        
        SEI                     Make sure interrupts are disabled
        
        LDAA    #$00            clear memory at A1ff
        STAA    $A1FF           
        
        LDD     TCNT            This is the value in the
*                               free running timer
*                               Note that the count period is
*                               500nS (8MHz crystal) unless
*                               TMSK2 is changed
        
        ADDD    #20000          Prepare to wait 10 mS to start
        STD     $0016           Store in timer compare register
        
        LDAA    #%10000000
        STAA    TFLG1           Clear timer 1 flag
        
        BSET    TMSK1   #%10000000      Enable interrupt OC1
*                                       in TMSK1
        CLI                     Enable interrupts


COP     LDAA    #%10101010      Endless loop resets cop
        STAA    COPRST
        LDAA    #%01010101
        STAA    COPRST
        BRA     COP


        ORG     $A100
*****
*       TIMER OC1 INTERRUPT SERVICE ROUTINE
*****
ISR

        LDD     TOC1            Get the number at comparison
        ADDD    #20000          increment for 10 mS
        STD     TOC1
        
        LDAA    $a1ff           Get old data
        ADDA    #$01            Add one        

        STAA    $a1ff           Store result
        
        LDAA    #%10000000
        STAA    TFLG1           Clear timer 1 flag        
        
        RTI

*****
*       Vector table interrupt vector
*****


        ORG     #$BFE8

        FDB     ISR

        ORG     #$FFE8

        FDB     ISR
